{-# LANGUAGE NoImplicitPrelude       #-}

module Main where

import Criterion
import Criterion.Main
import Data.Maybe (fromMaybe)
import Data.Set as Set
import Data.String.Conversions (cs)
import Data.Text (Text)
import Graph.BAC.Clustering.Safe
import Graph.BAC.Clustering.Eigen
import Graph.Lib.FGL
import Graph.Tools.Import
import Graph.Types
import Prelude (String)
import Protolude
import System.Environment (getArgs, withArgs)
import Text.Pretty.Simple (pPrint)
import qualified Data.Graph.Inductive.PatriciaTree as DGIP
import qualified Data.IntMap                       as Dict
import qualified Data.List                         as List
import qualified Eigen.Matrix                      as Matrix
import qualified Eigen.SparseMatrix                as SMatrix
import qualified Prelude                           as Prelude

setupEnv :: [String] -> IO (Dict [Text], Graph () ())
setupEnv [fp] = getUnlabGraph (WithFile fp)
setupEnv _    = getUnlabGraph Random

toLabel :: Ord a => Dict a -> Dict (Set Int) -> Dict (Set (Maybe a))
toLabel m d = Dict.map (Set.map (\n -> Dict.lookup n m)) d


main :: IO ()
main = do
  [fp] <- getArgs

{- -- benchmark
  withArgs [] $
    defaultMain
      [ env (setupEnv fp) $ \ ~(m,g) ->
        bench "bench" (nf (\ x -> withG x ((toLabel m) . parts . clusteringOptim 3 Conf)) g)
      ]

  (m,g) <- setupEnv [fp]
  pPrint $ (toLabel m) $ parts $ withG g (clusteringOptim 3 Conf)
-}

  LabelledGraph g' <- getGraph (WithFile fp)
  pPrint $ clusterGraph 3 g'
